package models

import (
	"crypto/rand"
	"gogs.mikescher.com/BlackForestBytes/goext/rext"
	"math/big"
)

//go:generate go run ../_gen/id-generate.go -- csids_gen.go

type EntityID interface {
	String() string
	Valid() error
	Prefix() string
	Raw() string
	CheckString() string
	Regex() rext.Regex
}

type JobLogID string //@csid:type [JLG]

type JobExecutionID string //@csid:type [JEX]

type SourceID string //@csid:type [SRC]

type PlaylistID string //@csid:type [PLS]

type TrackID string //@csid:type [TRK]

type FooterLinkID string //@csid:type [FLK]
